%global uname hacluster
%global gname haclient
%global pcmk_docdir %{_docdir}/%{name}
%global ocf_root %{_prefix}/lib/ocf
%global nagios_name nagios-agents-metadata
%global nagios_hash 105ab8a7b2c16b9a29cf1c1596b80136eeef332b
%global nagios_archive_github_url %{nagios_hash}#/%{nagios_name}-%{nagios_hash}.tar.gz
%global hacluster_id 189
%global git_pkgname Pacemaker

Summary:       Scalable High-Availability cluster resource manager
Name:          pacemaker
Version:       2.1.6
Release:       5%{?dist}
License:       GPLv2+ and LGPLv2+
Url:           https://www.clusterlabs.org/

Source0:       https://github.com/ClusterLabs/pacemaker/archive/refs/tags/%{git_pkgname}-%{version}.tar.gz
Source1:       https://codeload.github.com/ClusterLabs/%{nagios_name}/tar.gz/%{nagios_archive_github_url}

ExclusiveArch: aarch64 ppc64le x86_64 loongarch64

BuildRequires: autoconf automake gcc make libtool libtool-ltdl-devel gettext-devel
BuildRequires: coreutils findutils grep sed pkgconfig libqb-devel >= 0.17.0

BuildRequires: pkgconfig(glib-2.0) >= 2.42 libxml2-devel libxslt-devel
BuildRequires: libuuid-devel bzip2-devel docbook-style-xsl
BuildRequires: pkgconfig(dbus-1) gnutls-devel help2man ncurses-devel
BuildRequires: pam-devel libcmocka-devel pkgconfig(systemd) git
BuildRequires: corosync-devel >= 2.0.0 python3-devel

Requires:      corosync >= 2.0.0
Requires:      %{__python3}
Requires:      libqb >= 0.17.0
Requires:      resource-agents
Requires:      %{name}-libs = %{version}-%{release}
Requires:      %{name}-cluster-libs = %{version}-%{release}
Requires:      %{name}-cli = %{version}-%{release}
%{?systemd_requires}

Provides:      pcmk-cluster-manager = %{version}-%{release}
Provides:      bundled(gnulib) = 20200404

%description
Pacemaker is an advanced, scalable High-Availability cluster resource
manager.

It supports more than 16 node clusters with significant capabilities
for managing resources and dependencies.

It will run scripts at initialization, when machines go up or down,
when related resources fail and can be configured to periodically check
resource health.

Available rpmbuild rebuild options:
  --with(out) : cibsecrets coverage doc hardening pre_release profiling stonithd

%package cli
License:       GPLv2+ and LGPLv2+
Summary:       Command line tools for controlling Pacemaker clusters
Requires:      %{name}-libs = %{version}-%{release}
Requires:      perl-TimeDate
Requires:      procps-ng
Requires:      psmisc
Requires(post):coreutils
Recommends:    pcmk-cluster-manager = %{version}-%{release}
Recommends:    tar bzip2

%description cli
Pacemaker is an advanced, scalable High-Availability cluster resource
manager.

The %{name}-cli package contains command line tools that can be used
to query and control the cluster from machines that may, or may not,
be part of the cluster.

%package -n %{name}-libs
License:       GPLv2+ and LGPLv2+
Summary:       Core Pacemaker libraries
Requires(pre): shadow-utils
Requires:      %{name}-schemas = %{version}-%{release}

%description -n %{name}-libs
Pacemaker is an advanced, scalable High-Availability cluster resource
manager.

The %{name}-libs package contains shared libraries needed for cluster
nodes and those just running the CLI tools.

%package cluster-libs
License:       GPLv2+ and LGPLv2+
Summary:       Cluster Libraries used by Pacemaker
Requires:      %{name}-libs = %{version}-%{release}

%description cluster-libs
Pacemaker is an advanced, scalable High-Availability cluster resource
manager.

The %{name}-cluster-libs package contains cluster-aware shared
libraries needed for nodes that will form part of the cluster nodes.

%package remote
License:       GPLv2+ and LGPLv2+
Summary:       Pacemaker remote executor daemon for non-cluster nodes
Requires:      %{name}-libs = %{version}-%{release}
Requires:      %{name}-cli = %{version}-%{release}
Requires:      resource-agents
%{?systemd_ordering}
Provides:      pcmk-cluster-manager = %{version}-%{release}
Provides:      pcmk-cluster-manager = %{version}-%{release}

%description remote
Pacemaker is an advanced, scalable High-Availability cluster resource
manager.

The %{name}-remote package contains the Pacemaker Remote daemon
which is capable of extending pacemaker functionality to remote
nodes not running the full corosync/cluster stack.

%package -n %{name}-libs-devel
License:       GPLv2+ and LGPLv2+
Summary:       Pacemaker development package
Requires:      %{name}-libs = %{version}-%{release}
Requires:      %{name}-cluster-libs = %{version}-%{release}
Requires:      bzip2-devel
Requires:      corosync-devel >= 2.0.0
Requires:      glib2-devel
Requires:      libqb-devel
Requires:      libtool-ltdl-devel
Requires:      libuuid-devel
Requires:      libxml2-devel
Requires:      libxslt-devel

%description -n %{name}-libs-devel
Pacemaker is an advanced, scalable High-Availability cluster resource
manager.

The %{name}-libs-devel package contains headers and shared libraries
for developing tools for Pacemaker.

%package -n python3-%{name}
Summary:       Python libraries for Pacemaker
License:       LGPL-2.1-or-later
Requires:      python %{name}-libs = %{version}-%{release}
BuildArch:     noarch

%description -n python3-%{name}
This package provides python bindings for %{name}.


%package       cts
License:       GPLv2+ and LGPLv2+
Summary:       Test framework for cluster-related technologies like Pacemaker
Requires:      %{__python3}
Requires:      %{name}-libs = %{version}-%{release}
Requires:      %{name}-cli = %{version}-%{release}
Requires:      python3-%{name} = %{version}-%{release}
Requires:      procps-ng
Requires:      psmisc
Requires:      python3-systemd
BuildArch:     noarch

%description   cts
Test framework for cluster-related technologies like Pacemaker

%package       doc
License:       CC-BY-SA-4.0
Summary:       Documentation for Pacemaker
BuildArch:     noarch

%description   doc
Documentation for Pacemaker.

Pacemaker is an advanced, scalable High-Availability cluster resource
manager.

%package       schemas
License:       GPLv2+
Summary:       Schemas and upgrade stylesheets for Pacemaker
BuildArch:     noarch

%description   schemas
Schemas and upgrade stylesheets for Pacemaker

Pacemaker is an advanced, scalable High-Availability cluster resource
manager.

%package       nagios-plugins-metadata
License:       GPLv3
Summary:       Pacemaker Nagios Metadata
BuildArch:     noarch
Requires:      pcmk-cluster-manager

%description  nagios-plugins-metadata
The metadata files required for Pacemaker to execute the nagios plugin
monitor resources.

%prep
%autosetup -n %{name}-%{git_pkgname}-%{version}
sed -i configure.ac -e "s/-Wall/-Wall -Wno-format-truncation/"

%build
export systemdsystemunitdir=%{_unitdir}
export CFLAGS_HARDENED_EXE="%{?_hardening_cflags}"
export CFLAGS_HARDENED_LIB="%{?_hardening_cflags}"
export LDFLAGS_HARDENED_EXE="%{?_hardening_ldflags}"
export LDFLAGS_HARDENED_LIB="%{?_hardening_ldflags}"

./autogen.sh

%{configure}                                                                    \
        PYTHON=%{__python3}                                                   \
        --with-cibsecrets                                                       \
        --with-sbd-sync-default="true"                                         \
        --with-gnutls-priorities="@SYSTEM"                                      \
        --with-ocfdir=%{ocf_root}                                               \
        --with-concurrent-fencing-default=true                                  \
        --with-resource-stickiness-default=1                                    \
        --enable-compat-2.0                                                     \
        --disable-static                                                        \
        --with-initdir=%{_initrddir}                                            \
        --with-runstatedir=%{_rundir}                                           \
        --localstatedir=%{_var}                                                 \
        --with-nagios                                                             \
        --with-nagios-metadata-dir=%{_datadir}/pacemaker/nagios/plugins-metadata/ \
        --with-nagios-plugin-dir=%{_libdir}/nagios/plugins/                       \
        --with-version=%{version}-%{release}

%make_build

%check
make %{_smp_mflags} check
{ cts/cts-scheduler --run load-stopped-loop \
  && cts/cts-cli \
  && touch .CHECKED
} 2>&1 | sed 's/[fF]ail/faiil/g'
[ -f .CHECKED ] && rm -f -- .CHECKED

%install
%make_install docdir=%{pcmk_docdir}


mkdir -p %{buildroot}%{_datadir}/pacemaker/nagios/plugins-metadata
for file in $(find %{nagios_name}-%{nagios_hash}/metadata -type f); do
    install -m 644 $file %{buildroot}%{_datadir}/pacemaker/nagios/plugins-metadata
done


mkdir -p %{buildroot}%{_localstatedir}/lib/rpm-state/%{name}

find %{buildroot} -name '*.la' -type f -print0 | xargs -0 rm -f

rm -f %{buildroot}/%{_sbindir}/fence_legacy
rm -f %{buildroot}/%{_mandir}/man8/fence_legacy.*

rm -f %{buildroot}/%{_sbindir}/notifyServicelogEvent
rm -f %{buildroot}/%{_sbindir}/ipmiservicelogd

%{py_byte_compile %{__python3} %{buildroot}%{_datadir}/pacemaker/tests}
%{py_byte_compile %{__python3} %{buildroot}%{python3_sitelib}/cts}

%post
%systemd_post pacemaker.service

%preun
%systemd_preun pacemaker.service

%postun
%systemd_postun_with_restart pacemaker.service

%pre remote
systemctl --quiet is-active pacemaker_remote
if [ $? -eq 0 ] ; then
    mkdir -p %{_localstatedir}/lib/rpm-state/%{name}
    touch %{_localstatedir}/lib/rpm-state/%{name}/restart_pacemaker_remote
    systemctl stop pacemaker_remote >/dev/null 2>&1
else
    rm -f %{_localstatedir}/lib/rpm-state/%{name}/restart_pacemaker_remote
fi

%post remote
%systemd_post pacemaker_remote.service

%preun remote
%systemd_preun pacemaker_remote.service

%postun remote
%systemd_postun_with_restart pacemaker_remote.service
if [ "$1" -eq 0 ] ; then
    rm -f %{_localstatedir}/lib/rpm-state/%{name}/restart_pacemaker_remote
fi

%posttrans remote
if [ -e %{_localstatedir}/lib/rpm-state/%{name}/restart_pacemaker_remote ] ; then
    systemctl start pacemaker_remote >/dev/null 2>&1
    rm -f %{_localstatedir}/lib/rpm-state/%{name}/restart_pacemaker_remote
fi

%post cli
%systemd_post crm_mon.service
if [ "$1" -eq 2 ]; then
    { mv -fbS.rpmsave %{_var}/log/pacemaker.log* %{_var}/log/pacemaker \
      || mv -f %{_var}/log/pacemaker.log* %{_var}/log/pacemaker
    } >/dev/null 2>/dev/null || :
fi

%preun cli
%systemd_preun crm_mon.service

%postun cli
%systemd_postun_with_restart crm_mon.service

%pre -n %{name}-libs
getent group %{gname} >/dev/null || groupadd -r %{gname} -g %{hacluster_id}
getent passwd %{uname} >/dev/null || useradd -r -g %{gname} -u %{hacluster_id} -s /sbin/nologin -c "cluster user" %{uname}
exit 0


%files
%license licenses/GPLv2
%doc COPYING  ChangeLog
%config(noreplace) %{_sysconfdir}/sysconfig/pacemaker
%{_sbindir}/pacemakerd
%{_libexecdir}/pacemaker/*
%{_sbindir}/crm_attribute
%{_sbindir}/crm_master
%{_sbindir}/fence_watchdog
%{_unitdir}/pacemaker.service
%{_datadir}/pacemaker/alerts
%dir %attr (750, %{uname}, %{gname}) %{_var}/lib/pacemaker/cib
%dir %attr (750, %{uname}, %{gname}) %{_var}/lib/pacemaker/pengine
%{ocf_root}/resource.d/pacemaker/controld
%{ocf_root}/resource.d/pacemaker/remote
%{_mandir}/man7/pacemaker-controld.*
%{_mandir}/man7/pacemaker-schedulerd.*
%{_mandir}/man7/pacemaker-fenced.*
%{_mandir}/man7/ocf_pacemaker_controld.*
%{_mandir}/man7/ocf_pacemaker_remote.*
%{_mandir}/man8/crm_attribute.*
%{_mandir}/man8/crm_master.*
%{_mandir}/man8/fence_watchdog.*
%{_mandir}/man8/pacemakerd.*
%exclude %{_libexecdir}/pacemaker/cts-log-watcher
%exclude %{_libexecdir}/pacemaker/cts-support
%exclude %{_sbindir}/pacemaker-remoted
%exclude %{_sbindir}/pacemaker_remoted

%files cli
%license licenses/GPLv2
%doc COPYING
%doc ChangeLog
%{_sbindir}/attrd_updater
%{_sbindir}/cibadmin
%{_sbindir}/cibsecret
%{_sbindir}/crm_diff
%{_sbindir}/crm_error
%{_sbindir}/crm_failcount
%{_sbindir}/crm_mon
%{_sbindir}/crm_node
%{_sbindir}/crm_resource
%{_sbindir}/crm_rule
%{_sbindir}/crm_standby
%{_sbindir}/crm_verify
%{_sbindir}/crmadmin
%{_sbindir}/iso8601
%{_sbindir}/crm_shadow
%{_sbindir}/crm_simulate
%{_sbindir}/crm_report
%{_sbindir}/crm_ticket
%{_sbindir}/stonith_admin
%{_datadir}/pacemaker/report.collector
%{_datadir}/pacemaker/report.common
%{_datadir}/snmp/mibs/PCMK-MIB.txt
%dir %attr (750, root, %{gname}) %{_sysconfdir}/pacemaker
%config(noreplace) %{_sysconfdir}/logrotate.d/pacemaker
%config(noreplace) %{_sysconfdir}/sysconfig/crm_mon
%{_unitdir}/crm_mon.service
%dir %{ocf_root}
%dir %{ocf_root}/resource.d
%{ocf_root}/resource.d/pacemaker
%dir %attr (750, %{uname}, %{gname}) %{_var}/lib/pacemaker
%dir %attr (750, %{uname}, %{gname}) %{_var}/lib/pacemaker/blackbox
%dir %attr (750, %{uname}, %{gname}) %{_var}/lib/pacemaker/cores
%dir %attr (770, %{uname}, %{gname}) %{_var}/log/pacemaker
%dir %attr (770, %{uname}, %{gname}) %{_var}/log/pacemaker/bundles
%{_mandir}/man7/*
%{_mandir}/man8/*
%exclude %{ocf_root}/resource.d/pacemaker/controld
%exclude %{ocf_root}/resource.d/pacemaker/o2cb
%exclude %{ocf_root}/resource.d/pacemaker/remote
%exclude %{_mandir}/man7/pacemaker-controld.*
%exclude %{_mandir}/man7/pacemaker-schedulerd.*
%exclude %{_mandir}/man7/pacemaker-fenced.*
%exclude %{_mandir}/man7/ocf_pacemaker_controld.*
%exclude %{_mandir}/man7/ocf_pacemaker_o2cb.*
%exclude %{_mandir}/man7/ocf_pacemaker_remote.*
%exclude %{_mandir}/man8/crm_attribute.*
%exclude %{_mandir}/man8/crm_master.*
%exclude %{_mandir}/man8/fence_watchdog.*
%exclude %{_mandir}/man8/pacemakerd.*
%exclude %{_mandir}/man8/pacemaker-remoted.*

%files -n %{name}-libs
%license licenses/LGPLv2.1
%doc COPYING
%doc ChangeLog
%{_libdir}/libcib.so.*
%{_libdir}/liblrmd.so.*
%{_libdir}/libcrmservice.so.*
%{_libdir}/libcrmcommon.so.*
%{_libdir}/libpe_status.so.*
%{_libdir}/libpe_rules.so.*
%{_libdir}/libpacemaker.so.*
%{_libdir}/libstonithd.so.*

%files cluster-libs
%{_libdir}/libcrmcluster.so.*

%files remote
%config(noreplace) %{_sysconfdir}/sysconfig/pacemaker
%ghost %dir %{_localstatedir}/lib/rpm-state/%{name}
%{_unitdir}/pacemaker_remote.service
%{_sbindir}/pacemaker-remoted
%{_sbindir}/pacemaker_remoted
%{_mandir}/man8/pacemaker-remoted.*

%files doc
%license licenses/CC-BY-SA-4.0
%doc %{pcmk_docdir}

%files cts
%{python3_sitelib}/cts
%{_datadir}/pacemaker/tests
%{_libexecdir}/pacemaker/cts-log-watcher
%{_libexecdir}/pacemaker/cts-support
%{python3_sitelib}/pacemaker/_cts/

%files -n %{name}-libs-devel
%{_includedir}/pacemaker
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc

%files -n python3-%{name}
%license COPYING licenses/LGPLv2.1
%doc ChangeLog
%{python3_sitelib}/pacemaker/
%exclude %{python3_sitelib}/pacemaker/_cts/

%files schemas
%license licenses/GPLv2
%dir %{_datadir}/pacemaker
%{_datadir}/pacemaker/*.rng
%{_datadir}/pacemaker/*.xsl
%{_datadir}/pacemaker/api
%{_datadir}/pacemaker/base
%{_datadir}/pkgconfig/pacemaker-schemas.pc

%files nagios-plugins-metadata
%dir %{_datadir}/pacemaker/nagios
%dir %{_datadir}/pacemaker/nagios/plugins-metadata

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.6-5
- Rebuilt for loongarch release

* Fri May 10 2024 Pengda Dou <doupengda@loongson.cn> - 2.1.6-4
- [Type] other
- [DESC] add loongarch64 to ExclusiveArch

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.6-3
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.6-2
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Jul 12 2023 cunshunxia <cunshunxia@tencent.com> - 2.1.6-1
- upgrade to 2.1.6

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.4-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.4-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Feb 24 2023 cunshunxia <cunshunxia@tencent.com> - 2.1.4-1
- upgrade pacemaker to 2.1.4

* Thu Feb 09 2023 cunshunxia <cunshunxia@tencent.com> - 2.1.2-1
- initial build
